package org.geekfu.hippo;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

public class HippoMain {

	public static void main(String[] args) throws Exception{
		new HippoMain();
	}

	public HippoMain() throws Exception{
		
		Context ctx=Context.enter();
		
		
		reset(ctx, null);
	}

	public static void reset(Context ctx, Scriptable window) throws Exception {
		Context.exit();
		Context.enter();
		InputStream str=HippoMain.class.getResourceAsStream("/org/geekfu/hippo/system.js");
		Reader reader=new InputStreamReader(str);

		Scriptable scope=ctx.initStandardObjects();

		ScriptableObject.defineClass(scope, HostGameWindow.class);
		ScriptableObject.defineClass(scope, HostMap.class);
		ScriptableObject.defineClass(scope, HostSidebar.class);
		ScriptableObject.defineClass(scope, HostPiece.class);
		ScriptableObject.defineClass(scope, HostSystem.class);

		scope.put("_System", scope, ctx.newObject(scope, "System"));
		if(window==null){
			window=ctx.newObject(scope, "GameWindow");
		}
		
		scope.put("Window", scope, window);
		ctx.evaluateReader(scope, reader, "", 1, null);
	}
}
