package org.geekfu.hippo;

import java.io.File;
import java.io.FileReader;
import java.io.Reader;
import java.util.LinkedList;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.EvaluatorException;
import org.mozilla.javascript.ScriptableObject;

public class HostSystem extends ScriptableObject {

	private static LinkedList<String> paths=new LinkedList<String>();

	@Override
	public String getClassName() {
		return "System";
	}

	public void jsConstructor(){
		defineFunctionProperties(new String[]{"include"}, this.getClass(), ScriptableObject.READONLY);
	}

	public void include(String path){
		try {
			File file=new File(path);
			if(!file.isAbsolute()){
				if(!paths.isEmpty())
					file=new File(paths.getFirst(),path);
			}
			if(!file.exists()){
				throw new EvaluatorException("File "+file.getPath()+" not found.");
			}
			
			paths.addFirst(file.getParent());

			Context ctx=Context.enter();
			Reader reader;
			reader = new FileReader(file);
			ctx.evaluateReader(getParentScope(), reader, "", 1, null);
			paths.removeFirst();
		} catch (Exception e) {
			throw new EvaluatorException(e.getMessage());
		}

	}
}
