package org.geekfu.Cartographer;

import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.FileInputStream;

import javax.imageio.ImageIO;
import javax.swing.JFrame;

public class IsoTester {
    public static void main(String[] args) throws Exception {
        new IsoTester();
    }
    
    public IsoTester() throws Exception {
        JFrame window=new JFrame("IsoMap Tester");


        BufferedImage library=ImageIO.read(new FileInputStream("/Users/randrews/Desktop/art/IsometricArt.png"));
        ImageLibraryCell template=
        	new ImageLibraryCell(
        			ImageIO.read(new FileInputStream("/Users/randrews/Desktop/art/template.png")),
        			64,64,
        			0,0);
        ImageLibraryCell tractor=
        	new ImageLibraryCell(
        			ImageIO.read(new FileInputStream("/Users/randrews/Desktop/art/tractor/tractor.png")),
        			64,64,
        			0,0);
        
        int w=54,h=49; // Weirdly sized graphics

        ImageLibraryCell grass=new ImageLibraryCell(library,w,h,0,2);
        ImageLibraryCell wall=new ImageLibraryCell(library,w,h,6,6);

//        IsoMap map=new IsoMap(5,5,grass,new Dimension(54,49));
        IsoMap map=new IsoMap(7,3,template,new Dimension(64,64));
        map.putPiece(new MapLayoutConstraints(1,2),tractor);
        Thread t=map.animateMove(tractor,new MapLayoutConstraints(6,2),1000,50);
//        map.putPiece(new MapLayoutConstraints(2,1),new ImageLibraryCell(library,w,h,5,12));
//        
//        map.putPiece(new MapLayoutConstraints(2,2),new ImageLibraryCell(library,w,h,10,6));
//        map.putPiece(new MapLayoutConstraints(3,2),new ImageLibraryCell(library,w,h,4,6));
//        map.putPiece(new MapLayoutConstraints(1,2),wall);
//
//        for(int y=3;y!=6;y++)
//        		map.putPiece(new MapLayoutConstraints(1,y),new ImageLibraryCell(library,w,h,12,5));
//
//        map.putPiece(new MapLayoutConstraints(0,4),new ImageLibraryCell(library,w,h,6,12));
        
        window.getContentPane().add(map);
        window.pack();
        window.setVisible(true);
        
        t.start();
        
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
}
